> ## Documentation Index
> Fetch the complete documentation index at: https://docs.authsignal.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Generate Passkey Registration Options

> Generate options to register a new passkey.



## OpenAPI

````yaml client-api POST /user-authenticators/passkey/registration-options
openapi: 3.0.0
info:
  description: Authsignal's Client API.
  version: 1.0.0
  title: Client API
  termsOfService: https://www.authsignal.com/legal/terms-of-service
  contact:
    email: hello@authsignal.com
servers:
  - url: https://api.authsignal.com/v1/client
  - url: https://au.api.authsignal.com/v1/client
  - url: https://eu.api.authsignal.com/v1/client
  - url: https://ca.api.authsignal.com/v1/client
security:
  - bearerAuth: []
tags:
  - name: User authenticators
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: SMS
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: WhatsApp
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Email Magic Link
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Email OTP
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Authenticator App
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
  - name: Passkeys
    description: ''
    externalDocs:
      description: Find out more
      url: https://docs.authsignal.com
externalDocs:
  description: Find out more about Authsignal
  url: https://docs.authsignal.com
paths:
  /user-authenticators/passkey/registration-options:
    post:
      tags:
        - Passkeys
      summary: Generate Registration Options
      description: Generate options to register a new passkey.
      operationId: generateRegistrationOptions
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                username:
                  type: string
                  description: >-
                    The username which uniquely identifies the user, e.g. email
                    address. Will be inferred from an existing user identifier
                    if not passed.
                displayName:
                  type: string
                  description: >-
                    An additional identifier which will be displayed to the user
                    to help them recognize the passkey.
                securePaymentConfirmation:
                  type: boolean
                  description: >-
                    Register a Secure Payment Confirmation (SPC) credential for
                    use in 3-D Secure payments. When true, Authsignal forces a
                    platform authenticator with required user verification and
                    the WebAuthn `payment` extension, and marks the stored
                    credential payment-capable.
                instrumentDisplayName:
                  type: string
                  description: >-
                    An optional payment instrument label (e.g. "Visa ••1234")
                    persisted against an SPC credential and shown in future
                    payment dialogs. Only applies when
                    `securePaymentConfirmation` is true.
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  challengeId:
                    type: string
                    description: >-
                      The ID of the passkey challenge. Should be passed back to
                      the complete the registration.
                  options:
                    type: object
                    description: >-
                      The options for public key credential creation, based on
                      https://w3c.github.io/webauthn/#dictdef-publickeycredentialcreationoptionsjson.
                required:
                  - challengeId
                  - options
        '400':
          $ref: '#/components/responses/InvalidRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
components:
  responses:
    InvalidRequest:
      description: Invalid Request
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Unauthorized:
      description: Unauthorized
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorWithCode'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  schemas:
    Error:
      type: object
      properties:
        error:
          type: string
        errorDescription:
          type: string
      required:
        - error
    ErrorWithCode:
      type: object
      properties:
        error:
          type: string
        errorDescription:
          type: string
        errorCode:
          type: string
      required:
        - error
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        Use a short-lived token obtained from the Server API's Track Action
        endpoint. The token is valid for 10 minutes and should be passed in the
        Authorization header as 'Bearer {token}'.

````